SuperExec

This tool allows, within common user account, launching any application (executable, script, snap-in component) using administrator privileges.

It runs within Windows 2000, Windows XP, Windows 2003.
It does not run within Windows NT4 because some functions (cryptography, process management, network management) are not available.

It is similar to NT Resource Kit SU.EXE or RUNAS.EXE tools (Windows 2000 and above), but more powerful.

Major problem using these tools is administrator must be present near user computer in order to enter interactively his account name and password (and it is not good for system security if administrator communicates these informations).

SUPEREXEC frees this constraint, preparing application launching.
It records in Registry following parameters, which are fully encrypted :

  • User account (or users group) – local or global (domain)
  • Application name
  • Parameters passed to application
  • Working folder
  • User profile
  • Administrator account and password
  • Extra optional parameters :
    • Launching deadline
    • Launching counter

SUPEREXEC creates AUTOMATICALLY applications shortcuts or commands :

  • On user desktop
  • In Startup menu\programs\start
  • In Registry (key HKCU\Software\Microsoft\Windows\CurrentVersion\Runonce)
  • In login script of :
    • NetLogon folder (domain server)
    • %systemroot%\ system32\GroupPolicy\User\Scripts folder (local computer)

Application launching will be refused if:

  • Application is not authorized to user or a group where user is a member.
  • A deadline has been defined, and the current date is no longer valid.
  • A counter has been defined, and the count is exceeded.

Moreover, SUPEREXEC is able to run REMOTELY, and can manage any computer, member of workgroup or domain.
In that case, it self copies to remote computer in %systemroot% folder.

Comments :

  • Because of intrinsic network restrictions within Window XP Home Edition, SUPEREXEC is able to work locally only and not remotely within a computer using this system.
  • Another workgroup or domain browsing needs some time.
    We can disable network features (case of stand alone computer)
  • A field has been provided to typing manually computer name.
    It is useful in case a remote computer is intentionally hidden (command net config server /hidden:yes), which prevents displaying it in workgroup or domain computers list.
  • We can select a users group instead a user account. So allowed applications to this group will be authorized to any account member of this group. Associated shortcuts are created in %ALLUSERSPROFILE% folder (We cannot use Registry, because any entry in runonce key is deleted after executing).
  • Selected applications may be located on any computer of network, and not only on local user computer.
  • In case of console application (ipconfig, nbtstat, netstat, net time, ...), it will be launched using a dynamically created script in order to keep opened window until user closes it.
  • As far as remote computers are concerned, SUPEREXEC remotely activates :
    • remote registry service
    • administrative shares

SUPEREXEC software contains 4 files :

SuperExec.exe | main program, for administrators only, intended to plan applications.
SE.exe | run time program, for any users, intended to launch applications.
<language>\SuperExec.lib | localized file. It contains all messages and texts.
<language>\SuperExec.chm | this document.

SUPEREXEC use has been made as intuitive as possible.
Each field is provided with balloon tip, completed with message in status bar.

JCB © 2004 (http://www.bellamyjc.net)


General view

SuperExec main window is a dialog box divided in various areas :
(click on areas to get details)

Log record Log clear SuperExec settings Administrator name and password keyboarding Quit SuperExec Create new application Modify selected application Remove selected application Remove out of date applications Applyr changes Vérify informations into Registry Clear all applications lists on selected computer Copy fiels to remote computer General help Icons legend Applications Menu Network This field allows to type computer name not displayed in domains and computers list. It happens when an administrator has intentionally hidden this computer (command net config server /hidden:yes) Users Log

JCB © 2004


Network

This field displays domains and workgroups lists available from local computer, and computers list for each domain or workgroup.

Icons are :

Domain or workgroup
Computer
Selected computer
Disabled (by SuperExec) computer
It happens when operating system is :
  • Windows NT4 (or before)
  • XP Home Edition (only remote computer)

In this case, computer is displayed, but we cannot select it in order to configure applications.

A popup menu is available for each domain/workgroup or computer :

We can disable, refresh or (re)enable network browsing.
In case of network disabling or enabling, user must confirm :

It is useful to deactivate network browsing (into SuperExec) when local computer is stand-alone.
In return, when computer is connected to network again, it is a good idea to display other computers.

back General view


Users

This field displays selected computer users list.
It depends on software global settings.
This list contains domain accounts if computer is domain member.
See legend for more details.

A popup menu is available for each account :

Properties item shows some informations about selected account :

NB: In case of domain computer, and if local accounts displaying is enabled, SID (Security IDentifier) will be different according to we have selected local or global account.


Applications

This field shows applications list according to selected account(s) in users field.

A popup menu is available for each application :

Properties item shows some informations about selected application :

New or Modify item shows application settings dialog box.

Application removing shows a confirm dialog box :

It is possible to remove expired applications :

  • either because maximal launch counter has been reached
  • either because deadline has been missed

Il is possible to remove all applications on selected computer.
A confirm message is displayed :

"Apply changes" menu or button updates registry on selected computer (local or remote) :

  • removing some applications
  • writing allowed applications

Moreover, in case of remote computer, software's version checking is performed.

"Vérify" menu ore button is used to check registry informations for selected computer.
A feedback is displayed in log field :

Administrator's name is displayed, followed by password (hidden) and accounts number.
Then applications lists are displayed, according to each account (using format : "domain name\account" ou "computer name\account")
Each application is displayed as following :

  • application shortcut
  • deadline (potential)
  • maximal count (potential)
  • used profile :
    • U : user
    • A : administrator
    • D : default account

If we quit SuperExec, or if we change computer, and if changes (add, remove, or modify application) are pending without saving, alert dialog box is displayed :

If we press on :

  • Yes : alle changes are written into computer registry,
    then we quit program or we change computer.
  • No : changes are not written into computer registry,
    then we quit program or we change computer.
  • Cancel : changes are not written into computer registry,
    then we do not quit program neither change computer.

In case of remote computer, in order to assure informations compliance between registry and SuperExec software (se.exe), an existence and version checking is performed.
Files are copied if necessary or on demand :


Log

This field contains operations log, as potential error messages.
Text is displayed in HTML

In this example, SuperExec found on network a not manageable computer because very likely running XP Home

After changes saving, a feedback is displayed :

It is possible to save log in several formats :

  • HTML file (.htm extent)
  • Web archive (.mht extent)
  • text file (.txt extent)

By default, filename is made of "SuperExec" followed by date and time

It is possible to clear log content, restored to date and time only.


Menu

Menu tree is :

  • File
    • Log save
    • Log clear
    • Global settings
    • Administrator's settings
    • Quit
  • Applications
    • New
    • Selection modify
    • Selection remove
    • Remove x expired application(s)
  • Operations
    • Apply
    • Verify
    • All remove
    • SuperExec copy to xxxxx
  • Help
    • SuperExec help
    • Legend
    • License
    • About SuperExec


Global settings

This dialog box is used to configure SuperExec.

There are 4 tabs :

Startup
This tab defines :
  • language (nowadays french or english)
  • network support (network browsing, remote computers management)
    This checkbox will be unchecked in case of stand alone computer.
  • this dialog box displaying (or not) at startup.
Account displaying
By default, neither administrators nor guest accounts are displayed.
We can here define additional displaying.
  • guests
    by default, these accounts are disabled.
  • administrators
    we don not have to use SuperExec with these accounts.
  • groups
    in order to allow applications to users groups.
  • local
    This checkbox concerns only computers members of domain. By default, only global accounts (domain members) are displayed.
Applications extents
We can filter displayed applications by extents selection.

If "Others" checkbox is checked, all files are displayed.

Miscellanous
Error messages can be enabled or not during applications execution.

If silently execution is required, uncheck this checkbox.


Administrator

Administrator account identification is entered in this dialog box :

Account privileges are checked.


Application setting

Application setting dialog box is used to create new application, or to modify existing application.
Title shows computer and selected user or user group account.

There are 4 tabs :

  • Application
  • Workfolder
  • Shortcut
    Appearance is different according to :
    • user account
    • user group / Workgroup computer
    • user group / Domain computer
  • Limitations


Application tab

In left panel there is domains or workgroups tree, then computers tree and for each computer :
  • partitions (local computer)
  • administrative shares (remote computer)
    If administrative shares have been disabled, SuperExec will enable them.

In right panel there is folders tree for selected partition. and, for current selected folder, all files according to extent criterias (defined in global settings) (executables, scripts, ...)

We can define optional parameters that are passed to application.

In case of console mode application (or script), a checkbox (if checked) allows to keep opened windows after application executing.

Working folder tab

Shortcut tab (alone user account)
Shortcut tab (users group / computer member of workgroup)
Shortcut tab (users group / computer member of domain)

Limitations tab


Working folder tab

This tab defines application working folder.
It corresponds to "Start in..." field in shortcut properties.

In left panel there is selected computer tree :

  • partitions (local computer)
  • administrative shares (remote computer)

In right panel there is folders tree for selected partition.

A list box is used to select profile during application running.
We can choice :

  • administrator account profile
  • user profile.
  • default account profile.
Profile | HKCU hive | Environement
Administrator | Administrator | Administrator
User | Administrator | Administrator
Default account | Default account | User

HKEY_CURRENT_USER hive and environement used are dynamically displayed.

Application tab

Shortcut tab (alone user account)
Shortcut tab (users group / computer member of workgroup)
Shortcut tab (users group / computer member of domain)

Limitations tab


Shortcut tab (user)

This tab is used to :
  • Shortcut title.
    By default it is filename (without extent).
  • Shortcut location :
    • desktop
    • lStartup menu.
    • RunOnce key in HKCU\Software\... tree. It is useful in order to setup or update software.

    All script choices are disabled, because they concern only users groups.

Application tab
Working folder tab

Shortcut tab (users group / computer member of workgroup)
Shortcut tab (users group / computer member of domain)

Limitations tab


Shortcut tab (group/workgroup)

This tab is used to :
  • Shortcut title.
    By default it is filename (without extent).
  • Shortcut location :
    • desktop
    • Startup menu.
    • script
      • session opening
      • session closing
      Pressing Insert button inserts automatically command line into script.
      Pressing Save button records script file.

Remarks :

  • RunOnce key choice is disabled because a group (=many users) is concerned.
  • Session opening/closing scripts are defined using local policies MMC GPEDIT.MSC :
    User settings
    Scripts

Application tab
Working folder tab

Shortcut tab (alone user account)
Shortcut tab (users group / computer member of domain)

Limitations tab


Shortcut tab (group/domain)

This tab is used to :
  • Shortcut title.
    By default it is filename (without extent).
  • Shortcut location :
    • desktop
    • Startup menu.
    • logon script, on domain controller.
      Pressing Insert button inserts automatically command line into script.
      Pressing Save button records script file.

Remark :

  • RunOnce key choice is disabled because a group (=many users) is concerned.
  • Opening/closing session script choices are disabled in order to avoid redundancy with domain login script.

Application tab
Working folder tab

Shortcut tab (alone user account)
Shortcut tab (users group / computer member of workgroup)

Limitations tab


Limitations tab

This tab is used to set (optionnaly) :
  • Dead line (date and time) After this date, application launching will be refused.
  • maximal count. When this number is reached, any later application launching will be refused.

A checkbox is available to display or hide all messages during execution.

Date list box displays a calendar in order to easy select date :

Application tab
Working folder tab

Shortcut tab (alone user account)
Shortcut tab (users group / computer member of workgroup)
Shortcut tab (users group / computer member of domain)


Légende

Domain or workgroup
Selected domain or workgroup
Computer
Selected computer
Disabled computer (NT4 or remote XP HOME)
Guest account
Guest account (disabled)
User account
User account (disabled)
Administrator account
Administrator account (disabled)
Group
Local account or usergroup (workgroup)
Global account or usergroup (domain)
Desktop shortcut
Start menu shortcut
Registry shortcut (runonce)
Login script shortcut
Out of date application


About SuperExec

This dialog box displays software current version, and hyperlinks to author's site and mail.

Author's siteAuthor's mailDialog close


User license

This software is "freeware", according to following clauses:

  • Using is entirely free.
  • All copies are free, but the author strongly prefers that the files be distributed in the format originally released: INSTALLSE.EXE.
  • It is strictly forbidden to modify Copyright clauses.
  • The user must assume the entire risk of using the program
  • The author expressly disclaims any warranty for the software product. The software product and any related documentation is provided "as is" without warranty of any kind.
  • Distribution of the program or any work based on the program by a commercial organization to any third party is prohibited.
  • Your use of this software indicates your acceptance of this license agreement and warranty.


SUPEREXEC

SuperExec - 14/12/2004 20:32:54
RemoteRegistry service on DAKAR unreachable
DAKAR unavailable (very likely running XP Home)
Network error NetServerGetInfo : DAKAR
Accès refusé.
XP Home computers parameters are not remotely available

Computer GRANDBASSAM of Workgroup MAPLENET